
#define MAXNUM_PE_HELPLINES 181

static char *PEHelpText[MAXNUM_PE_HELPLINES] = {
" ",
"@t@b@l PTT Editor Help",
" ",
"  This form enables editing the phone company information maintained",
"  by xisp. With the exception of the first three input fields (the",
"  PTT name, the number of charging zones defined for this PTT and",
"  the number of tariff categories per zone), all information is split",
"  up in three sections. Section \"PTT charges\" includes general",
"  information on PTT charging method and currency. Section \"Zone",
"  information\" enables editing the names and attributes of charging",
"  zones for the selected PTT. Last, \"Category rules\" enables editing",
"  the tariff categories (or otherwise termed \"rules\") for each zone.",
"  Tariff categories are comprised of a (complex attribute) rule and a",
"  cost value. If the rule applies, then the cost value is applied.",
"  The application of a rule depends on whether or not the attributes",
"  for this rule apply to the current calendar date and/or time. Note",
"  that the PTT tariff calculation engine in xisp searches zone",
"  categories in a first to last sequence, and applies THE FIRST",
"  matching rule ONLY. This should be kept in mind when writing and/or",
"  modifying category rules for a PTT entry. In the following",
"  paragraphs, the functionality of each field on the PTT editor form",
"  is described. Also note that in the text below, the \"|\" character",
"  is used as a short-hand for the word \"or\".",
" ",
"@b@_  GENERAL",
" ",
"@b  PTT name:",
"    Enables changing the name string for the selected PTT.",
" ",
"@b  Charging zones:",
"    Used to specify the number of charging zones supported by the",
"    selected PTT entry.",
" ",
"@b  Categories/zone:",
"    Specifies the number of tariff categories (or rules) for each",
"    charging zone.",
" ",
" ",
"@b@_  PTT CHARGES",
" ",
"@b  By unit:",
"    Specifies that the selected PTT charges its customers by a",
"    \"unit\" which costs a fixed amount of money. The rate (in seconds)",
"    at which such units are charged changes according to tariff rules.",
" ",
"@b  Minimum units:",
"    The minimum number of units charged for a call. This should not",
"    be confused with the \"quantization\" used by PTTs which charge",
"    \"by unit\". I.e. if the selected PTT charges a minimum of one unit",
"    per phone-call, don't put \"1\" in this input field, as this will",
"    result in 2 units being recorded by xisp for every short call",
"    you make. The PTT charges you with a single unit even if you don't",
"    consume the time corresponding to one unit during your short call.",
" ",
"@b  Per minute:",
"    Specifies that the selected PTT charges its customers by the",
"    minute. This also implies that the quantization in time measurement",
"    (and consequently charging) by the PTT is set to 60 seconds. I.e. even",
"    if your call lasts 23 seconds, you'll be charged for one minute.",
" ",
"@b  Minimum cost:",
"    This field is enabled both for \"Per minute\" and \"Per second(s)\"",
"    charging schemes. It specifies the minimum amount of money charged",
"    by the selected PTT for each phone-call. This minimum charge may",
"    correspond to a certain amount of time in a linear relationship fashion,",
"    or it may not (i.e. minimum charge-time is non linear -- also see the",
"    \"Zone Information\" section).",
" ",
"@b  Per second(s):",
"    Specifies that the selected PTT charges its customers by a fixed",
"    number of seconds.",
" ",
"@b  Period:",
"    The charging period in number of seconds for \"Per second(s)\"",
"    charging schemes.",
" ",
"@b  Price/(unit|minute):",
"    The price in local currency for either each \"unit\", or for one",
"    minute if the charging scheme is \"Per minute\" or \"Per second(s)\".",
" ",
"@b  Currency:",
"    The local currency string for the selected PTT.",
" ",
"@b  Decimal digits for bill printouts:",
"    The number of decimal digits desired for saving/printing billing",
"    information in xisp's forms and log files.",
" ",
"@b  Currency placement:",
"    Specify \"Left\" or \"Right\" for the desired location of the",
"    currency string when printing out PTT charges.",
" ",
" ",
"@b@_  ZONE INFORMATION",
" ",
"@b  Zone:",
"    Use this browser to select a zone for browsing/editing its information,",
"    by clicking on a line. Double-click to edit the zone name.",
" ",
"@b  Default tariff:",
"    Specifies the default tariff. For \"By unit\" charging schemes",
"    it is measured in seconds per unit. For \"Per minute\" and \"Per",
"    second(s)\" charging schemes, it is measured in the currency",
"    specified in the \"Currency\" field, per minute.",
" ",
"@b  Minimum charge time length:",
"    This field is defined only for \"Per minute\" and \"Per second(s)\"",
"    charging schemes. It specifies the fixed amount of time for which",
"    the \"Minimum cost\" applies. This can either be \"Linear\", in which",
"    case the \"Minimum cost\" lasts for time equal to the ratio of its",
"    cost value over 60, times its \"Price/minute\", or \"Non-linear\", in",
"    which case a fixed time length can be specified for each zone.",
" ",
"@b  Length for this zone (seconds):",
"    When the \"Minimum charge time length\" is non-linear, the \"Minimum",
"    cost\" shall last for the specified number of seconds, when the",
"    selected charging zone is in effect. As expected, this field is",
"    defined only for \"Per minute\" and \"Per second(s)\" charging",
"    schemes.",
" ",
"@b  Extra discount for this zone:",
"    Specifies whether or not there is any special discount for the",
"    selected zone. If \"Yes\", the discount specified in \"Discount\" as",
"    a percentage of the full charge, will be applied if the phone-",
"    call start time is not between the specified starting and ending",
"    period within the 24-hour day. This field is not defined for \"By",
"    unit charging schemes\".",
" ",
" ",
"@b@_  CATEGORY RULES",
" ",
"@b  Category number:",
"    Using this counter, select the category (or otherwise \"rule\")",
"    number which you wish to browse or edit.",
" ",
"@b  Category type:",
"    Specifies the type of the selected rule. \"Weekday-special\" and",
"    \"Weekend-special\" are used to specify reduced tariffs for dates",
"    during the calendar year, usually falling between two holiday dates,",
"    or within a holiday season. An example could be the weekend between",
"    Christmas and New Year's eve. \"Holiday-absolute\" is used for fixed",
"    holiday dates in the calendar year, like for example, national holidays.",
"    \"Holiday-relative\" is used for specifying holidays relative to",
"    (Catholic) Easter Sunday which is specified using index number \"0\".",
"    Good Friday is specified as \"-2\" while Pentecost as \"50\".",
" ",
"@b  Apply zone discount:",
"    Allows or disallows application of \"Discount\" (from \"Zone",
"    information\" above) to this rule. This facility is not defined",
"    for \"By unit\" charging schemes.",
" ",
"@b  Zero minimum charge time length:",
"    Allows inhibiting application of the minimum charge time length",
"    to this rule. This is for accommodating cases whereby \"Minimum",
"    cost\" is applied to each phone-call WITHOUT being linked to a",
"    specified charge time length, i.e. when the selected PTT charges",
"    \"Minimum cost\" as a base and adds to it the amount corresponding",
"    to the time the call lasts. This facility is not defined for \"By unit\"",
"    charging schemes.",
" ",
"@b  Rule tariff:",
"    Specifies the rule tariff. For \"By unit\" charging schemes it",
"    is measured in seconds per unit. For \"Per minute\" and \"Per",
"    second(s)\" charging schemes it is measured in the currency",
"    specified in the \"Currency\" field, per minute.",
" ",
"@b  Rule date:",
"    For \"Holiday-absolute\" specifies the calendar date only. For",
"    \"Weekday-special\" and \"Weekend-special\" you also need to specify",
"    the \"End date\", as the \"Calendar date\" is the starting date in",
"    this case. For \"Holiday-relative\", specify the relative date in",
"    the \"Day relative to Easter Sunday\" field.",
" ",
"@b  Rule start time and Rule end time:",
"    The starting and ending time during which the selected rule",
"    applies. Note that the time interval includes the \"Rule start",
"    time\" but not the \"Rule end time\", i.e. for specifying that a",
"    rule applies from 08:00:00 to 10:59:59 inclusive, start time",
"    would be entered as 08:00:00 and ending time as 11:00:00. This",
"    follows standard PTT conventions with regards to changes in",
"    tariff as a function of time within the 24-hour day.",
" "
};

